import React, {Component} from 'react';
import {Course} from '../../common'
import './index.scss';
import {WithTab} from '@/HOCs'
import Swiper from 'react-mobile-swiper'
import createStyle from './createStyle'
import LazyLoad from 'react-lazy-load';

const animateTypes = Swiper.animateTypes

class Index extends Component {

    liveColse() {
        this.setState(status => ({
            isshow: !status.isshow,
        }));
    }

    toSubscribe() {
        this.setState(status => ({
            isshow: !status.isshow,
            toSubscribe: !status.toSubscribe
        }));
    }

    subscribeColse() {
        this.setState(status => ({
            toSubscribe: !status.toSubscribe
        }));
    }

    iphoneStep() {
        this.setState(status => ({
            step: 1
        }));
    }

    serverStep() {
        this.setState(status => ({
            step: 2
        }));
    }

    submit() {
        this.setState(status => ({
            success: true,
            toSubscribe: !status.toSubscribe
        }));
    }

    state = {
        issubscribe: 0,
        toSubscribe: false,
        isfollow: false,
        isshow: false,
        step: 0,
        success: false,
        dataList: [
            {
                'src': 'http://julyedu-img-public.oss-cn-beijing.aliyuncs.com/Public/Image/home/5afe433d01.png',
                'title': '啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊啊',
                'teacher': 'wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww',
                'time': '2343234',
                'isbuy': 0,
                'price0': 100,
                'price1': 1000
            },
            {
                'src': 'http://julyedu-img-public.oss-cn-beijing.aliyuncs.com/Public/Image/home/5afe433d01.png',
                'title': '啊啊啊啊啊啊啊啊啊啊啊',
                'teacher': 'wwwwww',
                'time': '2343234',
                'isbuy': 0,
                'price0': 100,
                'price1': 1000
            },
            {
                'src': 'http://julyedu-img-public.oss-cn-beijing.aliyuncs.com/Public/Image/home/5afe433d01.png',
                'title': '啊啊啊啊啊啊啊啊啊啊啊',
                'teacher': 'wwwwww',
                'time': '2343234',
                'isbuy': 0,
                'price0': 100,
                'price1': 1000
            },
            {
                'src': 'http://julyedu-img-public.oss-cn-beijing.aliyuncs.com/Public/Image/home/5afe433d01.png',
                'title': '啊啊啊啊啊啊啊啊啊啊啊',
                'teacher': 'wwwwww',
                'time': '2343234',
                'isbuy': 1,
                'price0': 200,
                'price1': 2000
            }
        ],
        tabdata: [
            {
                'src': 'http://julyedu-img-public.oss-cn-beijing.aliyuncs.com/Public/Image/home/5afe433d01.png',
                'name': '公开课'
            },
            {
                'src': 'http://julyedu-img-public.oss-cn-beijing.aliyuncs.com/Public/Image/home/5afe433d01.png',
                'name': '精品特惠'
            },
            {
                'src': 'http://julyedu-img-public.oss-cn-beijing.aliyuncs.com/Public/Image/home/5afe433d01.png',
                'name': '赚奖学金'
            },
            {
                'src': 'http://julyedu-img-public.oss-cn-beijing.aliyuncs.com/Public/Image/home/5afe433d01.png',
                'name': '每日一题'
            },
            {
                'src': 'http://julyedu-img-public.oss-cn-beijing.aliyuncs.com/Public/Image/home/5afe433d01.png',
                'name': '企业内训'
            }
        ]
    }

    toSearch() {
        window.location.href = '/search'
    }

    render() {
        return (
            <div className='index-box'>
                <div className='header'>
                    <img className="logo"
                         src="http://julyedu-img-public.oss-cn-beijing.aliyuncs.com/Public/img/index/logo.png" alt=""/>
                    <button className='to-app'>在APP打开</button>
                    <i className='iconfont iconiconfront- search' onClick={this.toSearch.bind(this)}></i>
                </div>

                <div className='index-swiper'>
                    <TopSwiper datalist={this.state.dataList}/>
                </div>

                <div className="tabbox">
                    <ul>
                        {
                            this.state.tabdata.map((item, index) => {
                                return (
                                    <li key={index}>
                                        <img src={item.src} alt=""/>
                                        <span>{item.name}</span>
                                    </li>
                                )
                            })
                        }
                    </ul>
                </div>
                <div className='category'>
                    <h2 className="title">近期直播</h2>
                    <ScrollBox dataList={this.state.dataList}/>
                    <div className="category-vip">
                        <a href="/#">
                            <img
                                src="http://julyedu-img-public.oss-cn-beijing.aliyuncs.com/Public/Image/home/5afe433d01.png"
                                alt=""/>
                        </a>
                    </div>
                </div>

                <CourseList courseList={this.state.dataList} title={'新上好课'} more={false} swiper={false}/>
                <CourseList courseList={this.state.dataList} title={'热门推荐'} more={true} swiper={true}/>
                <CourseList courseList={this.state.dataList} title={'基础入门'} more={true} swiper={false}/>
                <CourseList courseList={this.state.dataList} title={'就业班'} more={false} swiper={false}/>

                <div className="category all-course">
                    <p>查看全部课程</p>
                    <span>数学基础、数学结构、大数据实战、Python...</span>
                </div>

                {
                    this.state.isshow === true &&
                    <div className='live-room-box'>
                        <div className='live-room-content'>
                            <div className='course-banner'>
                                <div className='left'><span></span></div>
                                <div className='center'><img
                                    src="http://julyedu-img-public.oss-cn-beijing.aliyuncs.com/Public/Image/home/5afe433d01.png"
                                    alt=""/></div>
                                <div className='right'><span></span></div>
                            </div>
                            <div className='course-dec'>
                                <h2 className='title'>第四课：概率论算法精透</h2>
                                <p className='teacher'>讲师：林奔</p>
                                <p className='time'>时间：明晚20:00—22:00</p>
                            </div>
                            <div className='course-info'>
                                <ul>
                                    <li>简介：</li>
                                    <li className='text-overflow-2'>
                                        知识点1：图的定义 (有向图，无向图)定义四行。
                                    </li>
                                    <li className='text-overflow-2'>
                                        知识点2：拓扑排序实战项目：最短路（Floyd，Dijkstra，Bellmanford）。
                                    </li>
                                </ul>
                            </div>
                            <div className='course-subscribe'>
                                {
                                    this.state.issubscribe === 0 &&
                                    <button onClick={this.toSubscribe.bind(this)}>预约</button>
                                }
                                {
                                    this.state.issubscribe === 1 &&
                                    <span>直播尚未开始，敬请期待...</span>
                                }
                            </div>
                        </div>
                        <div className='live-room-close'>
                            <i onClick={this.liveColse.bind(this)} className={'iconfont iconiconfront-2 close'}></i>
                        </div>
                    </div>
                }
                {
                    this.state.toSubscribe === true &&
                    <div className='subscribe-box'>
                        {this.state.step === 0 &&
                        <div>
                            <div className='close-subscribe' onClick={this.subscribeColse.bind(this)}></div>
                            <div className='subscribe-content'>
                                <span className='title'>请选择即将直播时通知您的方式</span>
                                <button className={this.state.isfollow ? 'follow' : 'nofollow'}
                                        onClick={this.serverStep.bind(this)}>微信服务号通知
                                </button>
                                {
                                    this.state.isfollow === true &&
                                    <span className='tips'>关注服务号即代表预约成功</span>

                                }
                                <button className={this.state.isfollow ? 'follow' : 'nofollow'}
                                        onClick={this.iphoneStep.bind(this)}>手机短信通知
                                </button>
                            </div>
                        </div>
                        }
                        {this.state.step === 1 &&
                        <div>
                            <div className='close-subscribe' onClick={this.subscribeColse.bind(this)}></div>
                            <div className='iphone-content'>
                                <span className='title'>预约</span>
                                <p className='dec'>直播前会通过手机短信通知您，您可通过预留的手机号快捷登录参与学习：</p>
                                <input type="text" placeholder='请输入手机号'/>
                                <button className='submit' onClick={this.submit.bind(this)}>预约</button>
                            </div>
                        </div>
                        }
                        {this.state.step === 2 &&
                        <div>
                            <div className='close-subscribe' onClick={this.subscribeColse.bind(this)}></div>
                            <div className='iphone-content server-content'>
                                <p className='title'><i
                                    className={'iconfont icondanseshixintubiao-5'}></i><span>预约成功</span></p>
                                <p className='dec'>直播开始前会通过微信“服务通知”提醒您。 推荐预留手机号，届时可通过手机号登录直播 间直接学习：</p>
                                <input type="text" placeholder='请输入手机号'/>
                                <button className='submit' onClick={this.submit.bind(this)}>提交</button>
                            </div>
                        </div>
                        }
                    </div>
                }
                {
                    this.state.success === true &&
                    <div className='success'>预约成功</div>
                }
            </div>
        );
    }

}


function TopSwiper({datalist}){
    return(
        <Swiper type={animateTypes.CARD} loop={true} height={168} autoPlay={true} typePro createStyle={createStyle}>
            {datalist.map((item, index) => {
                return (
                    <div key={index}>
                        <img className="item" src={item.src} alt=""/>
                    </div>
                )
            })
            }
        </Swiper>
    )
}
function ContenSwiper({datalist}){
    return(
        <Swiper className='scroll' loop={true} type={animateTypes.DEFAULT} autoPlay>
            {datalist.map((item, index) => {
                return (
                    <div key={index}>
                        <img className="item" src={item.src} alt=""/>
                    </div>
                )
            })
            }
        </Swiper>
    )
}

function CourseList({courseList,title,more,swiper}){
    return(
        <div className='category'>
            <h2 className="title">{title}</h2>
            { more &&
            <a className="more" href="/#">更多 ></a>
            }
            {
                swiper &&
                <ContenSwiper datalist={courseList}/>
            }

            <LazyLoad offset={50}
                      onContentVisible={() => console.log('就业班')}
            >
                <ul className='course-detail'>
                    {courseList.map((item, index) => {
                        const top = (
                            <div>
                                {item.isbuy === 1 &&
                                <span className='audition'>
                                         <i className={'iconfont iconerji'}></i>试听</span>
                                }
                            </div>
                        )

                        const bottom = (
                            <div>
                                {item.isbuy === 0 && <p className="course-price">
                                    <span className="new">¥{item.price0}</span>
                                    <span className="old">¥{item.price1}</span>
                                </p>
                                }
                                {item.isbuy === 1 &&
                                <a href="/#" className="isbuy">已购买</a>
                                }
                            </div>
                        )
                        return (
                            <Course key={index} top={top} data={item} bottom={bottom}></Course>
                        )
                    })}
                </ul>
            </LazyLoad>
        </div>
    )
}
function ScrollBox({dataList}) {
    return(
        <div className='scroll-box'>
            <ul className='scroll-list'>
                {
                    dataList.map((item, index) => {
                        return (
                            <li key={index} className='scroll-item'>
                                <a href="/#">
                                    <img className="item-img" src={item.src} alt=""/>
                                    <div className="item-content">
                                        <h2 className="item-title">{item.title}</h2>
                                        <p className="item-teacher">讲师：{item.teacher}</p>
                                        <p className="item-time">时间：{item.time}</p>
                                    </div>
                                </a>
                            </li>
                        )
                    })
                }
            </ul>
        </div>
    )
}

export default WithTab(Index);
